//+---------------------------------------------------------------------------------------------------+
//|                                                                                FileMappingMT4.mqh |
//|                                                                                Copyright  Zhunko |
//|30.03.2010 - 13.04.2010                                                         vadim@zhunko.ru    |
//+---------------------------------------------------------------------------------------------------+
//|    "FileMappingMT4.dll"      .   |
//+---------------------------------------------------------------------------------------------------+
//|  "AIASM_Factors.dll"        "AIASM".  |
//+---------------------------------------------------------------------------------------------------+
//
#import "FileMappingMT4.dll"
 // 
 //     .    
 // 
 //===============================================================================================================================================================
 // 1.           /    
 //            .
 //       ,   .
 //            ,  NULL.
 int FileMapCreate(int    hFileUser,    //    .
                   string sNameFileMap, //    .
                   int    nMemorySize); //      .
 //===============================================================================================================================================================
 // 2.    .         ,  NULL.
 int FileMapOpen(string sNameFileMap); //   .
 //===============================================================================================================================================================
 // 3.       .
 //     : 1   ;
 //                       0   ;
 //                      -1     ;
 //                      -2    ;
 //                      -3      .
 int FileMapClear(string sNameFileMap); //   .
 //===============================================================================================================================================================
 // 4.        .   TRUE   ,  FALSE.
 int FileMapResize(string sNameFileMap, //   .
                   int    nMemorySize); //      .
 //===============================================================================================================================================================
 // 5.        .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseAll();
 //===============================================================================================================================================================
 // 6.               .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseHandleFile(int hFileUser); //    .
 //===============================================================================================================================================================
 // 7.         .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseName(string sNameFileMap); //   .
 //===============================================================================================================================================================
 // 8.       .
 //      TRUE       ,  FALSE.
 bool FileMapCloseHandle(int hFileMapping); //     .
 //===============================================================================================================================================================
 // 
 //                 .    
 // 
 //===============================================================================================================================================================
 // 9.         /    
 //            
 //             .
 //                  ,  NULL.
 int FileMapCreateViewOfFile(int    hFileUser,    //    .
                             string sNameFileMap, //    .
                             int    nMemorySize); //      .
 //===============================================================================================================================================================
 //10.                 .
 //                  ,  NULL.
 int FileMapOpenViewOfFile(string sNameFileMap); //   .
 //===============================================================================================================================================================
 //11.          .
 //                  ,  NULL.
 int FileMapViewOfFile(int hMapping); //    .
 //===============================================================================================================================================================
 //12.          .
 //          TRUE  FALSE   .
 bool FileMapUnViewOfFile(int pcAddress); //          .
 //===============================================================================================================================================================
 // 
 //            .    
 // 
 //===============================================================================================================================================================
 //13.           BOOL     .
 //        INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteBool(string sNameFileMap, //   .
                      int    nStartByte,   //      ,     .
                      int    nValue);      //   BOOL     .
 //===============================================================================================================================================================
 //14.           CHAR     .
 //        INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteChar(string sNameFileMap, //   .
                      int    nStartByte,   //      ,     .
                      int    nValue);      //   CHAR     .
 //===============================================================================================================================================================
 //15.           SHORT     .
 //        INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteShort(string sNameFileMap, //   .
                       int    nStartByte,   //      ,     .
                       int    nValue);      //   SHORT     .
 //===============================================================================================================================================================
 //16.           INT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteInt(string sNameFileMap, //   .
                     int    nStartByte,   //      ,     .
                     int    nValue);      //   INT     .
 //===============================================================================================================================================================
 //17.           FLOAT     .
 //        DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteFloat(string sNameFileMap, //   .
                       int    nStartByte,   //      ,     .
                       double dValue);      //   FLOAT     .
 //===============================================================================================================================================================
 //18.           DOUBLE     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteDouble(string sNameFileMap, //   .
                        int    nStartByte,   //      ,     .
                        double dValue);      //   DOUBLE     .
 //===============================================================================================================================================================
 //19.              .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteString(string sNameFileMap, //   .
                        int    nStartByte,   //      ,     .
                        string sString);     //      .
 //===============================================================================================================================================================
 // 
 //                   .    
 // 
 //===============================================================================================================================================================
 //20.              BOOL     .
 //         .     INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteBool(int  pcAddress,  //          .
                            int  nStartByte, //      ,      .
                            bool bValue);    //   BOOL     .
 //===============================================================================================================================================================
 //21.              CHAR     .
 //         .     INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteChar(int pcAddress,  //          .
                            int nStartByte, //      ,      .
                            int nValue);    //   CHAR     .
 //===============================================================================================================================================================
 //22.              SHORT     .
 //         .     INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteShort(int pcAddress,  //          .
                             int nStartByte, //      ,      .
                             int nValue);    //   SHORT     .
 //===============================================================================================================================================================
 //23.              INT     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteInt(int pcAddress,  //          .
                           int nStartByte, //      ,      .
                           int nValue);    //   INT     .
 //===============================================================================================================================================================
 //24.              FLOAT     .
 //        DOUBLE  FLOAT     .      .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteFloat(int    pcAddress,  //          .
                             int    nStartByte, //      ,      .
                             double dValue);    //   FLOAT     .
 //===============================================================================================================================================================
 //25.              DOUBLE     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteDouble(int    pcAddress,  //          .
                              int    nStartByte, //      ,      .
                              double dValue);    //   DOUBLE     .
 //===============================================================================================================================================================
 //26.                 .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteString(int    pcAddress,  //          .
                              int    nStartByte, //      ,      .
                              string sString);   //      .
 //===============================================================================================================================================================
 // 
 //            .    
 // 
 //===============================================================================================================================================================
 //27.           BOOL     .
 //         FALSE   .
 bool FileMapReadBool(string sNameFileMap, //   .
                      int    nStartByte);  //      ,     .
 //===============================================================================================================================================================
 //28.           CHAR     .
 //         NULL   .
 int FileMapReadChar(string sNameFileMap, //   .
                     int    nStartByte);  //      ,     .
 //===============================================================================================================================================================
 //29.           SHORT     .
 //         NULL   .
 int FileMapReadShort(string sNameFileMap, //   .
                      int    nStartByte);  //      ,     .
 //===============================================================================================================================================================
 //30.           INT     .
 //         NULL   .
 int FileMapReadInt(string sNameFileMap, //   .
                    int    nStartByte);  //      ,     .
 //===============================================================================================================================================================
 //31.           FLOAT     .
 //         NULL   .
 //        FLOAT     DOUBLE.
 double FileMapReadFloat(string sNameFileMap, //   .
                         int    nStartByte);  //      ,     .
 //===============================================================================================================================================================
 //32.           DOUBLE     .
 //         NULL   .
 double FileMapReadDouble(string sNameFileMap, //   .
                          int    nStartByte);  //      ,     .
 //===============================================================================================================================================================
 //33.              .
 //         .      NULL.
 string FileMapReadString(string sNameFileMap,   //   .
                          int    nStartByte,     //      ,     .
                          string sBuffer,        //    .
                          int    nLengthString); //      ().
 //===============================================================================================================================================================
 // 
 //                   .    
 // 
 //===============================================================================================================================================================
 //34.              BOOL     .
 //         .      FALSE   .
 bool FileMapSimpleReadBool(int pcAddress,   //          .
                            int nStartByte); //      ,      .
 //===============================================================================================================================================================
 //35.           CHAR     .      .
 //         NULL   .
 int FileMapSimpleReadChar(int pcAddress,   //          .
                           int nStartByte); //      ,      .
 //===============================================================================================================================================================
 //36.           SHORT     .      .
 //         NULL   .
 int FileMapSimpleReadShort(int pcAddress,   //          .
                            int nStartByte); //      ,      .
 //===============================================================================================================================================================
 //37.           INT     .      .
 //         NULL   .
 int FileMapSimpleReadInt(int pcAddress,   //          .
                          int nStartByte); //      ,      .
 //===============================================================================================================================================================
 //38.           FLOAT     .      .
 //         NULL   .     FLOAT     DOUBLE.
 double FileMapSimpleReadFloat(int pcAddress,   //          .
                               int nStartByte); //      ,      .
 //===============================================================================================================================================================
 //39.           DOUBLE     .      .
 //         NULL   .
 double FileMapSimpleReadDouble(int pcAddress,   //          .
                                int nStartByte); //      ,      .
 //===============================================================================================================================================================
 //40.              .      .
 //         .
 //        : "Error_1"      ;
 //                                        "Error_2"      ;
 string FileMapSimpleReadString(int pcAddress,   //          .
                                int nStartByte); //      ,      .
 //===============================================================================================================================================================
 // 
 //          .    
 // 
 //===============================================================================================================================================================
 //41.             BOOL     .
 //        INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteBoolArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           bool&  abArray[],    //       BOOL     .
                           int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //42.             CHAR     .
 //        INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteCharArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           int&   aiArray[],    //       CHAR     .
                           int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //43.             SHORT     .
 //        INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteShortArray(string sNameFileMap, //   .
                            int    nStartByte,   //      ,     .
                            int&   aiArray[],    //       SHORT     .
                            int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //44.             INT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteIntArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int&   aiArray[],    //       INT     .
                          int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //45.             FLOAT     .
 //        DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteFloatArray(string  sNameFileMap, //   .
                            int     nStartByte,   //      ,     .
                            double& adArray[],    //       FLOAT     .
                            int     nSizeArray);  //  .
 //===============================================================================================================================================================
 //46.             DOUBLE     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteDoubleArray(string  sNameFileMap, //   .
                             int     nStartByte,   //      ,     .
                             double& adArray[],    //       DOUBLE     .
                             int     nSizeArray);  //  .
 //===============================================================================================================================================================
 // 
 //                 .    
 // 
 //===============================================================================================================================================================
 //47.                BOOL     .
 //         .     INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteBoolArray(int   pcAddress,   //          .
                                 int   nStartByte,  //      ,      .
                                 bool& abArray[],   //       BOOL     .
                                 int   nSizeArray); //  .
 //===============================================================================================================================================================
 //48.                BOOL     .
 //         .     INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteCharArray(int  pcAddress,   //          .
                                 int  nStartByte,  //      ,      .
                                 int& aiArray[],   //       CHAR     .
                                 int  nSizeArray); //  .
 //===============================================================================================================================================================
 //49.                BOOL     .
 //         .     INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteShortArray(int  pcAddress,   //          .
                                  int  nStartByte,  //      ,      .
                                  int& aiArray[],   //       SHORT     .
                                  int  nSizeArray); //  .
 //===============================================================================================================================================================
 //50.                INT     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteIntArray(int  pcAddress,   //          .
                                int  nStartByte,  //      ,      .
                                int& aiArray[],   //       INT     .
                                int  nSizeArray); //  .
 //===============================================================================================================================================================
 //51.                FLOAT     .
 //         .     DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteFloatArray(int     pcAddress,   //          .
                                  int     nStartByte,  //      ,      .
                                  double& adArray[],   //       FLOAT     .
                                  int     nSizeArray); //  .
 //===============================================================================================================================================================
 //52.                DOUBLE     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteDoubleArray(int     pcAddress,   //          .
                                   int     nStartByte,  //      ,      .
                                   double& adArray[],   //       DOUBLE     .
                                   int     nSizeArray); //  .
 //===============================================================================================================================================================
 // 
 //          .    
 // 
 //===============================================================================================================================================================
 //53.           BOOL       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadBoolArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          bool&  abArray[],    //          BOOL   .
                          int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //54.           CHAR       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadCharArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int&   aiArray[],    //          CHAR   .
                          int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //55.           SHORT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadShortArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           int&   aiArray[],    //          SHORT   .
                           int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //56.           INT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadIntArray(string sNameFileMap, //   .
                         int    nStartByte,   //      ,     .
                         int&   aiArray[],    //          INT   .
                         int    nSizeArray);  //  .
 //===============================================================================================================================================================
 //57.           FLOAT       .
 //        FLOAT     DOUBLE    .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadFloatArray(string  sNameFileMap, //   .
                           int     nStartByte,   //      ,     .
                           double& adArray[],    //          FLOAT   .
                           int     nSizeArray);  //  .
 //===============================================================================================================================================================
 //58.           DOUBLE       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadDoubleArray(string  sNameFileMap, //   .
                            int     nStartByte,   //      ,     .
                            double& adArray[],    //          DOUBLE   .
                            int     nSizeArray);  //  .
 //===============================================================================================================================================================
 // 
 //                 .    
 // 
 //===============================================================================================================================================================
 //59.              BOOL       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadBoolArray(int   pcAddress,   //          .
                                int   nStartByte,  //      ,      .
                                bool& abArray[],   //          BOOL   .
                                int   nSizeArray); //  .
 //===============================================================================================================================================================
 //60.              CHAR       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadCharArray(int  pcAddress,   //          .
                                int  nStartByte,  //      ,      .
                                int& aiArray[],   //          CHAR   .
                                int  nSizeArray); //  .
 //===============================================================================================================================================================
 //61.              SHORT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadShortArray(int  pcAddress,   //          .
                                 int  nStartByte,  //      ,      .
                                 int& aiArray[],   //          SHORT   .
                                 int  nSizeArray); //  .
 //===============================================================================================================================================================
 //62.              INT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadIntArray(int  pcAddress,   //          .
                               int  nStartByte,  //      ,      .
                               int& aiArray[],   //          INT   .
                               int  nSizeArray); //  .
 //===============================================================================================================================================================
 //63.              FLOAT       .
 //         .     FLOAT     DOUBLE    .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadFloatArray(int     pcAddress,   //          .
                                 int     nStartByte,  //      ,      .
                                 double& adArray[],   //          FLOAT   .
                                 int     nSizeArray); //  .
 //===============================================================================================================================================================
 //64.              DOUBLE       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadDoubleArray(int     pcAddress,   //          .
                                  int     nStartByte,  //      ,      .
                                  double& adArray[],   //          DOUBLE   .
                                  int     nSizeArray); //  .
 //===============================================================================================================================================================
 // 
#import
//

